Thread Model
------------

![image](image/thread.jpg)

1. App connects to kids, fd is accepted by master thread.
2. Master thread sends fd to worker thread, a client object is created.
3. App uses `publish` command in redis-protocol to send logs.
4. Command is parsed by worker thread, logs is pushed to global message queue.
5. Notify other worker threads to fetch logs.
6. Notify storer thread to fetch logs, storer thread will save logs to store.
7. Other worker thread fetch logs.
8. Send logs to App waitting for the response of `subscribe` or `psubscribe`.

Source Explanation
------------------

1. master.cc 
	- run in master thread.
	- config parsing.
	- accept client and send fd to workers with round-robin algorithm.
	- garbage collection for old messages.
	- collect running status of all worker threads and storer thread.
	
2. worker.cc
	- run in worker thread.
	- process clients' command.
	
3. storer.cc
	- run in storer thread.
	- store message in global message queue.

4. client.cc
	- a worker thread may have many clients.

5. buffer.cc
	- a simple binary safe buffer string for request buffer and response buffer in client.
	
6. msgqueue.cc
	- the implementation of global message queue.

7. filesystem.cc
	- some function for file operation in filestore.
	
8. conf.cc
	- config parser.



